function win = checkWin(board, minToWin)
    % board - matrix with 0s, 1s and 2s
    % minToWin - minimum consecutive values

    % Initialize win condition as false
    win = false;
    [N, M] = size(board); % Get the size of the board

    % Check rows and columns
    for i = 1:N
        if findConsecutive(board(i,:), minToWin)
            win = true;
            return;
        end
    end
    for j = 1:M
        if findConsecutive(board(:,j), minToWin)
            win = true;
            return;
        end
    end

    % Check diagonals
    % Includes diagonals in both directions
    for d = -(N-1):(M-1)
        diagMain = diag(board, d);
        diagAnti = diag(flipud(board), d);
        if findConsecutive(diagMain, minToWin) || findConsecutive(diagAnti, minToWin)
            win = true;
            return;
        end
    end
end

function isConsecutive = findConsecutive(vector, minToWin)
    % Initialize
    isConsecutive = false;
    count = 1;
    
    % Only proceed if the vector has enough elements to check
    if length(vector) < minToWin
        return;
    end
    
    for i = 2:length(vector)
        if vector(i) == vector(i-1) && vector(i) ~= 0
            count = count + 1;
            if count >= minToWin
                isConsecutive = true;
                return;
            end
        else
            count = 1;
        end
    end
end