function dispBoard(board, timeout)
% Function to display a board of arbitrary size NxM
% Displaying the player moves 1 == X
% 2 == O
[N, M] = size(board);
imgSize = 600; % Size of the image in pixels
hFig = figure(1); % open or reactivate figure
if isempty(figure(1).Children) % does not exist axes yet
   hFig.Position = [(groot().ScreenSize(3:4) - imgSize)/2, imgSize, imgSize];
   hFig.UserData.oldBoard = zeros(N, M);
   hAx = axes(hFig, 'Position', [0, 0, 1, 1], 'XGrid', true, 'YGrid', true, ...
      'XTick', 0:M, 'YTick', 0:N, 'XLim', [0, M], 'YLim', [1, N+1]);
   hFig.UserData.XLine = line(hAx, 'Marker', 'X', 'MarkerSize', 20, 'Color', 'r', ...
      'XData', zeros(1, 0), 'YData', zeros(1, 0), 'LineStyle', 'none');
   hFig.UserData.OLine = line(hAx, 'Marker', 'O', 'MarkerSize', 17, 'Color', 'g', ...
      'XData', zeros(1, 0), 'YData', zeros(1, 0), 'LineStyle', 'none');
   drawnow();
end
logChange = xor(board, hFig.UserData.oldBoard);
hFig.UserData.oldBoard = board;
[row, col] = find(logChange);

   if board(logChange) == 1
      oldXData = hFig.UserData.OLine.XData;
      oldYData = hFig.UserData.OLine.YData;
      set(hFig.UserData.OLine, 'XData', [oldXData, col - 0.5], ...
         'YData', [oldYData, row + 0.5])
   elseif board(logChange) == 2
      oldXData = hFig.UserData.XLine.XData;
      oldYData = hFig.UserData.XLine.YData;
      set(hFig.UserData.XLine, 'XData', [oldXData, col - 0.5], ...
         'YData', [oldYData, row + 0.5])
   end
   drawnow();
pause(timeout); % Pause to allow visualization of the board state before proceeding
end